--[[**************************************************
Licensed under the GNU General Public License version 2
(c) 2005 Carl J. Gruber
cgruber@hyperpixel.net
*************************************************]]
function Debug(x,y, mappos)
	screen:print(0, 0, "X=", green)
	screen:print(15, 0, x, green)
	screen:print(45, 0, "Y=", green)
	screen:print(60, 0, y, green)
	screen:print(90, 0, "M=", green)
	screen:print(105,0, mappos, green)
	screen:print(135,0, "N=", green)
	screen:print(150,0, num_moves,green)
	screen:print(180,0, "L=", green)
	screen:print(195,0, level, green)
end


--screen:blit(0, 0, background, 0, 0, background:width(), background:height(), false)


function DisplaySplash()
splash = Image.load("images/luasplash.png")
screen:clear()
screen:blit(0, 0, splash, 0, 0, splash:width(), splash:height(), false)
screen.waitVblankStart()
screen.flip()
screen.waitVblankStart(70)
splash=nil
end

function StartupPosition()
x=16 
y=8
screen:clear()
for i=1, 112 do
	if (i==1) then 
	      if (gamefield[i]==-1) then
				screen:blit(16, 8, player)
				return i
				end
		elseif (i==15) then y=40 x=16
		elseif (i==29) then y=72 x=16
		elseif (i==43) then y=104 x=16
		elseif (i==57) then y=136 x=16
		elseif (i==71) then y=168 x=16
		elseif (i==85) then y=200 x=16
		elseif (i==99) then y=232 x=16
	end

	if (gamefield[i]== -1) then screen:blit(x, y, player) return i end
x=x+32

end
end 
function DrawScreen()
x1=16 
y1=8
screen:clear()
for i=1, 112 do
	if (i==1) then 
	      if (gamefield[i]==1) then
				screen:blit(16, 8, block)
		  elseif (gamefield[i]==-2) then
			  screen:blit(16,8, drop)
		  elseif (gamefield[i]==3) then
			  screen:blit(16,8, win)
	  end
		elseif (i==15) then y1=40 x1=16
		elseif (i==29) then y1=72 x1=16
		elseif (i==43) then y1=104 x1=16
		elseif (i==57) then y1=136 x1=16
		elseif (i==71) then y1=168 x1=16
		elseif (i==85) then y1=200 x1=16
		elseif (i==99) then y1=232 x1=16
	end

	if (gamefield[i]== 1) then
		screen:blit(x1, y1, block)
	elseif (gamefield[i] ==-2) then
		screen:blit(x1,y1, drop)
	elseif (gamefield[i] == 2) then
		screen:blit(x1,y1, stone)
	elseif (gamefield[i] == 3) then
	    screen:blit(x1,y1, win)
	end
x1=x1+32

end

Debug(x,y, mappos)
screen:blit(x,y,player) 
screen.waitVblankStart(5)
screen.flip()
end

function Move()
pad = Controls.read()

if pad:down() then
	if(gamefield[mappos+14] < 1) then
	y=y+32
	mappos=mappos+14
	num_moves= num_moves+1
	
	elseif(gamefield[mappos+14]==2) then
	  if(gamefield[mappos+28]==0 or gamefield[mappos+28] ==-1)then
		mappos=mappos+14
		gamefield[mappos+14] = 2
		gamefield[mappos]=0
		y=y+32
		num_moves= num_moves+1
	  elseif(gamefield[mappos+28]==-2) then
		mappos=mappos+14
		gamefield[mappos+14]=3
		gamefield[mappos]=0
		y=y+32
		num_moves=num_moves+1
	  end
	elseif(gamefield[mappos+14]==3) then
	 if(gamefield[mappos+28]<1)then
		mappos=mappos+14
		if (gamefield[mappos+14] ~= -2) then
		gamefield[mappos+14] = 2
		else 
		gamefield[mappos+14]=3
		end 
		gamefield[mappos]=-2
		y=y+32
		num_moves= num_moves+1
	  end
	end
	
end
--[[
if (pad:analogY() < -32) then 
	if(gamefield[mappos-14]<1) then
	y=y-32
	mappos=mappos-14
	end
end

if (pad:analogY() > 32) then 
	if(gamefield[mappos+14]<1) then
	y=y+32
	mappos=mappos+14
	end
end

if (pad:analogX() < -32) then 
	if(gamefield[mappos-1]<1) then
	x=x-32
	mappos=mappos-1
	end
end

if (pad:analogX() > 32) then 
	if(gamefield[mappos+1]<1) then
	x=x+32
	mappos=mappos+1
	end
end
]]
if pad:up() then
	if(gamefield[mappos-14] < 1) then
	y=y-32
	mappos=mappos-14
	num_moves= num_moves+1
	
	elseif(gamefield[mappos-14]==2) then
	  if(gamefield[mappos-28]==0 or gamefield[mappos-28] ==-1)then
		mappos=mappos-14
		gamefield[mappos-14] = 2
		gamefield[mappos]=0
		y=y-32
		num_moves= num_moves+1
	  elseif(gamefield[mappos-28]==-2) then
		mappos=mappos-14
		gamefield[mappos-14]=3
		gamefield[mappos]=0
		y=y-32
		num_moves=num_moves+1
	  end
	elseif(gamefield[mappos-14]==3) then
	 if(gamefield[mappos-28]<1)then
		mappos=mappos-14
		if (gamefield[mappos-14] ~= -2) then
		gamefield[mappos-14] = 2
		else 
		gamefield[mappos-14]=3
		end 
		gamefield[mappos]=-2
		y=y-32
		num_moves= num_moves+1
	  end
	end
	
end

if pad:left() then
   if(gamefield[mappos-1] < 1) then
	x=x-32
	mappos=mappos-1
	num_moves= num_moves+1
	
	elseif(gamefield[mappos-1]==2) then
	  if(gamefield[mappos-2]==0 or gamefield[mappos-2] ==-1)then
		mappos=mappos-1
		gamefield[mappos-1] = 2
		gamefield[mappos]=0
		x=x-32
		num_moves= num_moves+1
	  elseif(gamefield[mappos-2]==-2) then
		mappos=mappos-1
		gamefield[mappos-1]=3
		gamefield[mappos]=0
		x=x-32
		num_moves=num_moves+1
	  end
	elseif(gamefield[mappos-1]==3) then
	 if(gamefield[mappos-2]<1)then
		mappos=mappos-1
		if (gamefield[mappos-1] ~= -2) then
		gamefield[mappos-1] = 2
		else 
		gamefield[mappos-1]=3
		end 
		gamefield[mappos]=-2
		x=x-32
		num_moves= num_moves+1
	  end
	end
end

if pad:right() then
   if(gamefield[mappos+1] < 1) then
	x=x+32
	mappos=mappos+1
	num_moves= num_moves+1
	
	elseif(gamefield[mappos+1]==2) then
	  if(gamefield[mappos+2]==0 or gamefield[mappos+2] ==-1)then
		mappos=mappos+1
		gamefield[mappos+1] = 2
		gamefield[mappos]=0
		x=x+32
		num_moves= num_moves+1
	  elseif(gamefield[mappos+2]==-2) then
		mappos=mappos+1
		gamefield[mappos+1]=3
		gamefield[mappos]=0
		x=x+32
		num_moves=num_moves+1
	  end
	elseif(gamefield[mappos+1]==3) then
	 if(gamefield[mappos+2]<1)then
		mappos=mappos+1
		if (gamefield[mappos+1] ~= -2) then
		gamefield[mappos+1] = 2
		else 
		gamefield[mappos+1]=3
		end 
		gamefield[mappos]=-2
		x=x+32
		num_moves= num_moves+1
	  end
	end
end

if pad:r() then
	level=level+1
	LoadLevel(level)
end

if pad:l() then
	if (level==1) then
		LoadLevel(level)
	else
		level = level -1
		LoadLevel(level)
	end
end

if pad:start() then
	return 1
end 

end
function LevelComplete()
for i=1, 112 do
	if(gamefield[i]==-2) then return 0	end
end
screen.waitVblankStart(200)
level=level+1
return 1 --nothing found we won
end

function LoadLevel()

num_moves=0
levelnum = tostring(level)
map=string.format("%s%s", "levels/", levelnum)
map=string.format("%s%s", map, ".lua")
if(io.open(map, r)==nil) then --open the file first to make sure it's there
	level=1 --wrap back to start
	screen.waitVblankStart(60)  --short delay
	LoadLevel(1) --call yourself to load first level since we ran out.
else  -- yep it's there better close it
	io.close()
	if(level~=1) then 
	screen.waitVblankStart(60) --short delay
	end
	dofile(map)
	mappos=StartupPosition()
	return 1
end

end


--Game Inits
--dofile("levels/1.lua")
System.usbDiskModeActivate()
green = Color.new(0, 255, 0)
x=0 y=0
mappos=0 num_moves=0
level=1
block = Image.load("images/block.png")
player = Image.load("images/player.png")
drop = Image.load("images/drop.png")
stone = Image.load("images/stone.png")
win = Image.load("images/win.png")
LoadLevel(1)
DisplaySplash()
--mappos = StartupPosition()

while not false do --game loop

if (Move()==1) then break end  --if start is pressed quit
DrawScreen()
if (LevelComplete()==1) then 
	LoadLevel(level)
end

end

